#include <stdio.h>
#include <string.h>
// Verify that snprintf() returns a NULL terminated string on overrun conditions. erco 12/30/09
#ifdef _WIN32
#define snprintf _snprintf	// microsoft 'deprecated' this function, so must have leading '_'
#endif /*MICROSOFT*/
int main() {
    int ret;
    char ss[20];
    strcpy(ss, "12345678XY"); 	// 'X' and 'Y' should never be touched or seen in the following
    ret=snprintf(ss, 8, "1234%s","56");     fprintf(stderr,"RET=%d, SS='%s': TEST RESULT: %s\n", ret, ss, (ss[8]=='X'&&ss[9]=='Y'&&strlen(ss)<8)?"OK":"FAIL!");
    ret=snprintf(ss, 8, "1234%s","567");    fprintf(stderr,"RET=%d, SS='%s': TEST RESULT: %s\n", ret, ss, (ss[8]=='X'&&ss[9]=='Y'&&strlen(ss)<8)?"OK":"FAIL!");
    ret=snprintf(ss, 8, "1234%s","5678");   fprintf(stderr,"RET=%d, SS='%s': TEST RESULT: %s\n", ret, ss, (ss[8]=='X'&&ss[9]=='Y'&&strlen(ss)<8)?"OK":"FAIL!");
    ret=snprintf(ss, 8, "1234%s","56789");  fprintf(stderr,"RET=%d, SS='%s': TEST RESULT: %s\n", ret, ss, (ss[8]=='X'&&ss[9]=='Y'&&strlen(ss)<8)?"OK":"FAIL!");
    ret=snprintf(ss, 8, "1234%s","567890"); fprintf(stderr,"RET=%d, SS='%s': TEST RESULT: %s\n", ret, ss, (ss[8]=='X'&&ss[9]=='Y'&&strlen(ss)<8)?"OK":"FAIL!");
    return(0);
}
